const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const lesson_plans = sequelize.define(
    'lesson_plans',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

week_start_at: {
        type: DataTypes.DATE,
      
      

      },

week_end_at: {
        type: DataTypes.DATE,
      
      

      },

plan_content: {
        type: DataTypes.TEXT,
      
      

      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"draft",


"submitted",


"approved"

        ],

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  lesson_plans.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity






































//end loop



    db.lesson_plans.belongsTo(db.staff_members, {
      as: 'teacher',
      foreignKey: {
        name: 'teacherId',
      },
      constraints: false,
    });

    db.lesson_plans.belongsTo(db.class_sections, {
      as: 'class_section',
      foreignKey: {
        name: 'class_sectionId',
      },
      constraints: false,
    });

    db.lesson_plans.belongsTo(db.subjects, {
      as: 'subject',
      foreignKey: {
        name: 'subjectId',
      },
      constraints: false,
    });



    db.lesson_plans.hasMany(db.file, {
      as: 'attachments',
      foreignKey: 'belongsToId',
      constraints: false,
      scope: {
        belongsTo: db.lesson_plans.getTableName(),
        belongsToColumn: 'attachments',
      },
    });


    db.lesson_plans.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.lesson_plans.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return lesson_plans;
};


